/*____________________________________________________________________________*\
 *

 Copyright (c) 1997 John Roy. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. Redistributions of any form whatsoever and all advertising materials 
    mentioning features must contain the following
    acknowledgment:
    "This product includes software developed by John Roy
    (http://www.johnroy.com/pi3/)."

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: Pi3Expr.h$
 * $Date: Sun Aug 10 06:36:33 1997$
 *
 Description:
\*____________________________________________________________________________*/
/* $HeaderTop:$ */

#ifndef PI3EXPR_H_
#define PI3EXPR_H_

#include "Pi3API.h"

/*____________________________________________________________________________*\
 *
 Typedefs:
\*____________________________________________________________________________*/
#if defined(PI3_INTERNAL)

/* --- Implementation sees the type of Pi3Expression --- */
typedef struct _Pi3Expression Pi3Expression;

#else

/* --- Externally Pi3Expression is opaque --- */
typedef int Pi3Expression;

#endif
typedef int (* FnPi3Write)( PIHTTP *, void *, char *, int );

/*____________________________________________________________________________*\
 *
 Name:
	Pi3Expression_new

 Synopsis:
	Pi3Expression *Pi3Expression_new( const char *pExpression,
		FnPi3Write *pParameters, Pi3String *pErrorDescription )

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI Pi3Expression *Pi3Expression_new( const char *pExpression,
	FnPi3Write *pParameters, Pi3String *pErrorDescription );

/*____________________________________________________________________________*\
 *
 Name:
	Pi3Expression_delete

 Synopsis:
	int Pi3Expression_delete( Pi3Expression *pExpression );

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int Pi3Expression_delete( Pi3Expression *pExpr );

/*____________________________________________________________________________*\
 *
 Name:
	Pi3Expression_write

 Synopsis:
	int Pi3Expression_write( Pi3Expression *pExpression, PIHTTP *pPIHTTP,
		void *pData, char *pBuffer, int iBufferLength );

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int Pi3Expression_write( Pi3Expression *pExpression,
	PIHTTP *pPIHTTP, void *pData, char *pBuffer, int iBufferLength );

#endif	/* PI3EXPR_H_ */

